<?php
namespace Teknisa\PLA\Modules\Medicao\Controllers;

use Zeedhi\Framework\DTO;
use Setforms2\Shared\ORM\DateTime;

class Pla02100EmissaoDasRetiradas extends \Zeedhi\Framework\Controller\Report {

    protected $qr2Strategy;
    protected $environment;
    protected $entityManager;
    protected $birtStategy;
    protected $reportMapping = array(
        'PLA02100' => array(
            'strategy' => 'BIRT',
            'parameterMapping'  => array(
                'CDFILIAL'   	=> 'P_CDFILIAL',
                'DATAINI'     	=> 'P_DTINICIAL',
                'DATAFIN'     	=> 'P_DTFINAL',
                'CDALMOXARIFE' 	=> 'P_CDALMOXARIFE',
                'CDLOCALESTOQ'	=> 'P_CDLOCALESTOQ',
                'LISTASERV'   	=> 'P_CDSERVFILI',
                'NIVEL'     	=> 'P_NIVEL',
                'NPTOTALIZA' 	=> 'P_NRTAMACNIVEL',
                'NRTAMCODIGO'  => 'P_NRTAMCODIGO',
                'QTRETIRADA'    => 'P_QTRETIRADA',
                'NRORG'         => 'P_NRORG' 
                
            ),
        ),
		'PLA02101' => array(
            'strategy' => 'BIRT',
            'parameterMapping'  => array(
                'CDFILIAL'   	=> 'P_CDFILIAL',
                'DATAINI'     	=> 'P_DTINICIAL',
                'DATAFIN'     	=> 'P_DTFINAL',
                'CDALMOXARIFE'  => 'P_CDALMOXARIFE',
                'CDLOCALESTOQ'	=> 'P_CDLOCALESTOQ',
                'LISTASERV'   	=> 'P_CDSERVFILI',
                'NIVEL'     	=> 'P_NIVEL',
                'NPTOTALIZA'    => 'P_NRTAMACNIVEL',
                'NRTAMCODIGO'   => 'P_NRTAMCODIGO',
                'QTRETIRADA'    => 'P_QTRETIRADA',
                'NRORG'         => 'P_NRORG'
            ),
        ),
		'PLA02102' => array(
            'strategy' => 'BIRT',
            'parameterMapping'  => array(
                'CDFILIAL'   	=> 'P_CDFILIAL',
                'DATAINI'     	=> 'P_DTINICIAL',
                'DATAFIN'     	=> 'P_DTFINAL',
                'CDALMOXARIFE'  => 'P_CDALMOXARIFE',
                'CDLOCALESTOQ'	=> 'P_CDLOCALESTOQ',
                'LISTASERV'   	=> 'P_CDSERVFILI',
                'NIVEL'     	=> 'P_NIVEL',
                'NPTOTALIZA'    => 'P_NRTAMACNIVEL',
                'NRTAMCODIGO'   => 'P_NRTAMCODIGO',
                'QTRETIRADA'    => 'P_QTRETIRADA',
                'NRORG'         => 'P_NRORG'
            ),
        ),
		'PLA02103' => array(
            'strategy' => 'BIRT',
            'parameterMapping'  => array(
                'CDFILIAL'   	=> 'P_CDFILIAL',
                'DATAINI'     	=> 'P_DTINICIAL',
                'DATAFIN'     	=> 'P_DTFINAL',
                'CDALMOXARIFE'  => 'P_CDALMOXARIFE',
                'CDLOCALESTOQ'	=> 'P_CDLOCALESTOQ',
                'LISTASERV'   	=> 'P_CDSERVFILI',
                'NIVEL'     	=> 'P_NIVEL',
                'NPTOTALIZA' 	=> 'P_NRTAMACNIVEL',
                'NRTAMCODIGO'   => 'P_NRTAMCODIGO',
                'QTRETIRADA'    => 'P_QTRETIRADA',
                'NRORG'         => 'P_NRORG'
            ),
        ),
		'PLA02104' => array(
            'strategy' => 'BIRT',
            'parameterMapping'  => array(
                'CDFILIAL'   	=> 'P_CDFILIAL',
                'DATAINI'     	=> 'P_DTINICIAL',
                'DATAFIN'     	=> 'P_DTFINAL',
                'CDALMOXARIFE'  => 'P_CDALMOXARIFE',
                'CDLOCALESTOQ'	=> 'P_CDLOCALESTOQ',
                'LISTASERV'   	=> 'P_CDSERVFILI',
                'NIVEL'     	=> 'P_NIVEL',
                'NPTOTALIZA'    => 'P_NRTAMACNIVEL',
                'NRTAMCODIGO'   => 'P_NRTAMCODIGO',
                'QTRETIRADA'    => 'P_QTRETIRADA',
                'NRORG'         => 'P_NRORG'
            ),
        ),
	);

    public function __construct($reportService, $qr2Strategy, $environment, $entityManager, $birtStategy) {
        
        $this->reportService	= $reportService;
        $this->qr2Strategy      = $qr2Strategy;
        $this->reportService	= $reportService;
        $this->environment      = $environment;
        $this->entityManager    = $entityManager;
        $this->birtStrategy     = $birtStategy;

    }

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
    	$row = $request->getRow();
    	$this->qr2Strategy->setQr2Type($row['QR2TYPE']);
    	$this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
    	$row['NRORG'] = $this->environment->getNrOrg();
    	if(!isset($row['LISTASERV']) || !$row['LISTASERV'] || $row['LISTASERV'] === 'T')
            $row['LISTASERV'] = implode('_', $this->getServicos($row));
        if(!isset($row['CDALMOXARIFE']) || !$row['CDALMOXARIFE'])
            $row['CDALMOXARIFE'] = 'T';
        if(!isset($row['CDLOCALESTOQ']) || !$row['CDLOCALESTOQ'])
            $row['CDLOCALESTOQ'] = 'T';
            
    	$row['NIVEL'] = intval($row['NPTOTALIZACAO']) == 0 ? 'N' : 'S';

    }
    
    private function getServicos($row) {
        $query = "SELECT
                        S.CDSERVFILI
                    FROM
                        SERVICO    S,
                        FILIOPER   F
                    WHERE
                        S.CDFILIAL = :CDFILIAL
                        AND ( F.CDOPERADOR = :CDOPERADOR )
                        AND ( F.CDFILIAL = S.CDFILIAL )
                        AND ( S.NRORG = :NRORG )
                        AND S.IDSERVATIV <> 'N'";
        $params = array(
            'CDFILIAL'   => $row['CDFILIAL'],
            'CDOPERADOR' => $this->environment->getCdOperador(),
            'NRORG'      => $this->environment->getNrOrg()
        );
        
        $std = $this->entityManager->getConnection()->prepare($query);
        $std->execute($params);
        return array_column($std->fetchAll(), 'CDSERVFILI');
    }
}